import{s as qe,f as Ee,n as Me,o as Qe}from"../chunks/scheduler.37c15a92.js";import{S as Se,i as We,g as s,s as i,r,A as He,h as l,f as n,c as o,j as Ae,u as h,x as c,k as ue,y as Ce,a,v as m,d as p,t as f,w as g}from"../chunks/index.7cb9c9b8.js";import{Q as ce}from"../chunks/Question.f95a37ca.js";import{H as d,E as Re}from"../chunks/EditOnGithub.858acfec.js";function ze(de){let u,D,B,j,w,F,$,we='The best way to learn and <a href="https://www.coursera.org/lecture/learning-how-to-learn/illusions-of-competence-BuFzf" rel="nofollow">to avoid the illusion of competence</a> <strong>is to test yourself.</strong> This will help you to find <strong>where you need to reinforce your knowledge</strong>.',G,v,U,x,$e="<summary>Solution</summary> <p>Reinforcement learning is a <strong>framework for solving control tasks (also called decision problems)</strong> by building agents that learn from the environment by interacting with it through trial and error and <strong>receiving rewards (positive or negative) as unique feedback</strong>.</p>",V,y,J,b,ve,K,T,xe="At every step:",N,_,ye="<li>Our Agent receives <strong>__</strong> from the environment</li> <li>Based on that <strong>__</strong> the Agent takes an <strong>__</strong></li> <li>Our Agent will move to the right</li> <li>The Environment goes to a <strong>__</strong></li> <li>The Environment gives a <strong>__</strong> to the Agent</li>",X,L,Y,k,Z,A,ee,q,te,E,ne,M,ae,Q,be='<summary>Solution</summary> <p>In Reinforcement Learning, we need to <strong>balance how much we explore the environment and how much we exploit what we know about the environment</strong>.</p> <ul><li><p><em>Exploration</em> is exploring the environment by <strong>trying random actions in order to find more information about the environment</strong>.</p></li> <li><p><em>Exploitation</em> is <strong>exploiting known information to maximize the reward</strong>.</p></li></ul> <img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit1/expexpltradeoff.jpg" alt="Exploration Exploitation Tradeoff" width="100%"/>',ie,S,oe,W,Te='<summary>Solution</summary> <ul><li>The Policy π <strong>is the brain of our Agent</strong>. It’s the function that tells us what action to take given the state we are in. So it defines the agent’s behavior at a given time.</li></ul> <img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit1/policy_1.jpg" alt="Policy"/>',se,H,re,C,_e="<summary>Solution</summary> <ul><li>Value-based methods is one of the main approaches for solving RL problems.</li> <li>In Value-based methods, instead of training a policy function, <strong>we train a value function that maps a state to the expected value of being at that state</strong>.</li></ul>",le,R,he,z,Le="<summary>Solution</summary> <ul><li>In <em>Policy-Based Methods</em>, we learn a <strong>policy function directly</strong>.</li> <li>This policy function will <strong>map from each state to the best corresponding action at that state</strong>. Or a <strong>probability distribution over the set of possible actions at that state</strong>.</li></ul>",me,I,ke="Congrats on finishing this Quiz 🥳, if you missed some elements, take time to read again the chapter to reinforce (😏) your knowledge, but <strong>do not worry</strong>: during the course we’ll go over again of these concepts, and you’ll <strong>reinforce your theoretical knowledge with hands-on</strong>.",pe,P,fe,O,ge;return w=new d({props:{title:"Quiz",local:"quiz",headingTag:"h1"}}),v=new d({props:{title:"Q1: What is Reinforcement Learning?",local:"q1-what-is-reinforcement-learning",headingTag:"h3"}}),y=new d({props:{title:"Q2: Define the RL Loop",local:"q2-define-the-rl-loop",headingTag:"h3"}}),L=new ce({props:{choices:[{text:"an action a0, action a0, state s0, state s1, reward r1",explain:"At every step: Our Agent receives **state s0** from the environment. Based on that **state s0** the Agent takes an **action a0**. Our Agent will move to the right. The Environment goes to a **new state s1**. The Environment gives **a reward r1** to the Agent."},{text:"state s0, state s0, action a0, new state s1, reward r1",explain:"",correct:!0},{text:"a state s0, state s0, action a0, state s1, action a1",explain:"At every step: Our Agent receives **state s0** from the environment. Based on that **state s0** the Agent takes an **action a0**. Our Agent will move to the right. The Environment goes to a **new state s1**. The Environment gives **a reward r1** to the Agent."}]}}),k=new d({props:{title:"Q3: What’s the difference between a state and an observation?",local:"q3-whats-the-difference-between-a-state-and-an-observation",headingTag:"h3"}}),A=new ce({props:{choices:[{text:"The state is a complete description of the state of the world (there is no hidden information)",explain:"",correct:!0},{text:"The state is a partial description of the state",explain:""},{text:"The observation is a complete description of the state of the world (there is no hidden information)",explain:""},{text:"The observation is a partial description of the state",explain:"",correct:!0},{text:"We receive a state when we play with chess environment",explain:"Since we have access to the whole checkboard information.",correct:!0},{text:"We receive an observation when we play with chess environment",explain:"Since we have access to the whole checkboard information."},{text:"We receive a state when we play with Super Mario Bros",explain:"We only see a part of the level close to the player, so we receive an observation."},{text:"We receive an observation when we play with Super Mario Bros",explain:"We only see a part of the level close to the player.",correct:!0}]}}),q=new d({props:{title:"Q4: A task is an instance of a Reinforcement Learning problem. What are the two types of tasks?",local:"q4-a-task-is-an-instance-of-a-reinforcement-learning-problem-what-are-the-two-types-of-tasks",headingTag:"h3"}}),E=new ce({props:{choices:[{text:"Episodic",explain:"In Episodic task, we have a starting point and an ending point (a terminal state). This creates an episode: a list of States, Actions, Rewards, and new States. For instance, think about Super Mario Bros: an episode begin at the launch of a new Mario Level and ending when you’re killed or you reached the end of the level.",correct:!0},{text:"Recursive",explain:""},{text:"Adversarial",explain:""},{text:"Continuing",explain:"Continuing tasks are tasks that continue forever (no terminal state). In this case, the agent must learn how to choose the best actions and simultaneously interact with the environment.",correct:!0}]}}),M=new d({props:{title:"Q5: What is the exploration/exploitation tradeoff?",local:"q5-what-is-the-explorationexploitation-tradeoff",headingTag:"h3"}}),S=new d({props:{title:"Q6: What is a policy?",local:"q6-what-is-a-policy",headingTag:"h3"}}),H=new d({props:{title:"Q7: What are value-based methods?",local:"q7-what-are-value-based-methods",headingTag:"h3"}}),R=new d({props:{title:"Q8: What are policy-based methods?",local:"q8-what-are-policy-based-methods",headingTag:"h3"}}),P=new Re({props:{source:"https://github.com/huggingface/deep-rl-class/blob/main/units/en/unit1/quiz.mdx"}}),{c(){u=s("meta"),D=i(),B=s("p"),j=i(),r(w.$$.fragment),F=i(),$=s("p"),$.innerHTML=we,G=i(),r(v.$$.fragment),U=i(),x=s("details"),x.innerHTML=$e,V=i(),r(y.$$.fragment),J=i(),b=s("img"),K=i(),T=s("p"),T.textContent=xe,N=i(),_=s("ul"),_.innerHTML=ye,X=i(),r(L.$$.fragment),Y=i(),r(k.$$.fragment),Z=i(),r(A.$$.fragment),ee=i(),r(q.$$.fragment),te=i(),r(E.$$.fragment),ne=i(),r(M.$$.fragment),ae=i(),Q=s("details"),Q.innerHTML=be,ie=i(),r(S.$$.fragment),oe=i(),W=s("details"),W.innerHTML=Te,se=i(),r(H.$$.fragment),re=i(),C=s("details"),C.innerHTML=_e,le=i(),r(R.$$.fragment),he=i(),z=s("details"),z.innerHTML=Le,me=i(),I=s("p"),I.innerHTML=ke,pe=i(),r(P.$$.fragment),fe=i(),O=s("p"),this.h()},l(e){const t=He("svelte-u9bgzb",document.head);u=l(t,"META",{name:!0,content:!0}),t.forEach(n),D=o(e),B=l(e,"P",{}),Ae(B).forEach(n),j=o(e),h(w.$$.fragment,e),F=o(e),$=l(e,"P",{"data-svelte-h":!0}),c($)!=="svelte-rgmkvd"&&($.innerHTML=we),G=o(e),h(v.$$.fragment,e),U=o(e),x=l(e,"DETAILS",{"data-svelte-h":!0}),c(x)!=="svelte-hwjwin"&&(x.innerHTML=$e),V=o(e),h(y.$$.fragment,e),J=o(e),b=l(e,"IMG",{src:!0,alt:!0}),K=o(e),T=l(e,"P",{"data-svelte-h":!0}),c(T)!=="svelte-9mg24u"&&(T.textContent=xe),N=o(e),_=l(e,"UL",{"data-svelte-h":!0}),c(_)!=="svelte-1iffy4z"&&(_.innerHTML=ye),X=o(e),h(L.$$.fragment,e),Y=o(e),h(k.$$.fragment,e),Z=o(e),h(A.$$.fragment,e),ee=o(e),h(q.$$.fragment,e),te=o(e),h(E.$$.fragment,e),ne=o(e),h(M.$$.fragment,e),ae=o(e),Q=l(e,"DETAILS",{"data-svelte-h":!0}),c(Q)!=="svelte-lhagbu"&&(Q.innerHTML=be),ie=o(e),h(S.$$.fragment,e),oe=o(e),W=l(e,"DETAILS",{"data-svelte-h":!0}),c(W)!=="svelte-su9zbv"&&(W.innerHTML=Te),se=o(e),h(H.$$.fragment,e),re=o(e),C=l(e,"DETAILS",{"data-svelte-h":!0}),c(C)!=="svelte-g9n3n1"&&(C.innerHTML=_e),le=o(e),h(R.$$.fragment,e),he=o(e),z=l(e,"DETAILS",{"data-svelte-h":!0}),c(z)!=="svelte-aae5od"&&(z.innerHTML=Le),me=o(e),I=l(e,"P",{"data-svelte-h":!0}),c(I)!=="svelte-uzf1og"&&(I.innerHTML=ke),pe=o(e),h(P.$$.fragment,e),fe=o(e),O=l(e,"P",{}),Ae(O).forEach(n),this.h()},h(){ue(u,"name","hf:doc:metadata"),ue(u,"content",Ie),Ee(b.src,ve="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit1/rl-loop-ex.jpg")||ue(b,"src",ve),ue(b,"alt","Exercise RL Loop")},m(e,t){Ce(document.head,u),a(e,D,t),a(e,B,t),a(e,j,t),m(w,e,t),a(e,F,t),a(e,$,t),a(e,G,t),m(v,e,t),a(e,U,t),a(e,x,t),a(e,V,t),m(y,e,t),a(e,J,t),a(e,b,t),a(e,K,t),a(e,T,t),a(e,N,t),a(e,_,t),a(e,X,t),m(L,e,t),a(e,Y,t),m(k,e,t),a(e,Z,t),m(A,e,t),a(e,ee,t),m(q,e,t),a(e,te,t),m(E,e,t),a(e,ne,t),m(M,e,t),a(e,ae,t),a(e,Q,t),a(e,ie,t),m(S,e,t),a(e,oe,t),a(e,W,t),a(e,se,t),m(H,e,t),a(e,re,t),a(e,C,t),a(e,le,t),m(R,e,t),a(e,he,t),a(e,z,t),a(e,me,t),a(e,I,t),a(e,pe,t),m(P,e,t),a(e,fe,t),a(e,O,t),ge=!0},p:Me,i(e){ge||(p(w.$$.fragment,e),p(v.$$.fragment,e),p(y.$$.fragment,e),p(L.$$.fragment,e),p(k.$$.fragment,e),p(A.$$.fragment,e),p(q.$$.fragment,e),p(E.$$.fragment,e),p(M.$$.fragment,e),p(S.$$.fragment,e),p(H.$$.fragment,e),p(R.$$.fragment,e),p(P.$$.fragment,e),ge=!0)},o(e){f(w.$$.fragment,e),f(v.$$.fragment,e),f(y.$$.fragment,e),f(L.$$.fragment,e),f(k.$$.fragment,e),f(A.$$.fragment,e),f(q.$$.fragment,e),f(E.$$.fragment,e),f(M.$$.fragment,e),f(S.$$.fragment,e),f(H.$$.fragment,e),f(R.$$.fragment,e),f(P.$$.fragment,e),ge=!1},d(e){e&&(n(D),n(B),n(j),n(F),n($),n(G),n(U),n(x),n(V),n(J),n(b),n(K),n(T),n(N),n(_),n(X),n(Y),n(Z),n(ee),n(te),n(ne),n(ae),n(Q),n(ie),n(oe),n(W),n(se),n(re),n(C),n(le),n(he),n(z),n(me),n(I),n(pe),n(fe),n(O)),n(u),g(w,e),g(v,e),g(y,e),g(L,e),g(k,e),g(A,e),g(q,e),g(E,e),g(M,e),g(S,e),g(H,e),g(R,e),g(P,e)}}}const Ie='{"title":"Quiz","local":"quiz","sections":[{"title":"Q1: What is Reinforcement Learning?","local":"q1-what-is-reinforcement-learning","sections":[],"depth":3},{"title":"Q2: Define the RL Loop","local":"q2-define-the-rl-loop","sections":[],"depth":3},{"title":"Q3: What’s the difference between a state and an observation?","local":"q3-whats-the-difference-between-a-state-and-an-observation","sections":[],"depth":3},{"title":"Q4: A task is an instance of a Reinforcement Learning problem. What are the two types of tasks?","local":"q4-a-task-is-an-instance-of-a-reinforcement-learning-problem-what-are-the-two-types-of-tasks","sections":[],"depth":3},{"title":"Q5: What is the exploration/exploitation tradeoff?","local":"q5-what-is-the-explorationexploitation-tradeoff","sections":[],"depth":3},{"title":"Q6: What is a policy?","local":"q6-what-is-a-policy","sections":[],"depth":3},{"title":"Q7: What are value-based methods?","local":"q7-what-are-value-based-methods","sections":[],"depth":3},{"title":"Q8: What are policy-based methods?","local":"q8-what-are-policy-based-methods","sections":[],"depth":3}],"depth":1}';function Pe(de){return Qe(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Fe extends Se{constructor(u){super(),We(this,u,Pe,ze,qe,{})}}export{Fe as component};
